/*
 * DrvCMP.c
 *
 *  Created on: 2011/11/11
 *      Author: Eric.Lai
 */
#include "DrvCMP.h"
#include "SpecialMacro.h"

unsigned int DrvCMP_Open (unsigned int uPowerMode ,unsigned int uCPDF,unsigned int uCPOR)
{
	unsigned int l_reg,l_data,ReturnVal;
	ReturnVal=0;
	l_reg=CMP_CTRL;
	if((uPowerMode<(CMPLP_MAX+1))&&(uCPDF<(CPDF_MAX+1))&&(uCPOR<(CPOR_MAX+1)))
	{
		(uPowerMode==1) ? (l_data=(1<<CMPLP)):(l_data=(0<<CMPLP));
		(uCPDF==1) ? (l_data+=(1<<CPDF)):(l_data+=(0<<CPDF));
		(uCPOR==1) ? (l_data+=(1<<CPOR)):(l_data+=(0<<CPOR));
		l_data+=(1<<CMPLP_MASK)|(1<<CPDF_MASK)|(1<<CPOR_MASK)|(1<<ENCMP)|(1<<ENCMP_MASK)|(inw(l_reg)&0x00ff0000);
		outw(l_reg,l_data);
	}else ReturnVal=E_DRVCMP_ARGUMENT;
	return ReturnVal;
}

void DrvCMP_Close(void)
{
	unsigned int l_reg,l_data;
	l_reg=CMP_CTRL;
	l_data=(1<<ENCMP_MASK)|(inw(l_reg)&0x00ff0000);
	outw(l_reg,l_data);
}

unsigned int DrvCMP_Input(unsigned int uPositiveInput,unsigned int uNegativeInput,unsigned int uInputSwitch)
{
	unsigned int l_reg,l_data,ReturnVal;
	ReturnVal=0;
	l_reg=CMP_INPUT;
	if((uPositiveInput<(CPPS_MAX+1))&&(uNegativeInput<(CPNS_MAX+1))&&(uInputSwitch<(CPIS_MAX+1)))
	{
		l_data=(uPositiveInput<<CPPS)|(CPPS_MAX<<(CPPS+MASK))|(uNegativeInput<<CPNS)|(CPNS_MAX<<(CPNS+MASK));
		outw(l_reg,l_data);
		l_reg=CMP_CTRL;
		l_data=(uInputSwitch<<CPIS)|(CPIS_MAX<<CPIS_MASK)|(inw(l_reg)&0x00ff0000);
		outw(l_reg,l_data);
	}else ReturnVal=E_DRVCMP_ARGUMENT;
	return ReturnVal;
}

void DrvCMP_Enable(void)
{
	unsigned int l_reg,l_data;
	l_reg=CMP_CTRL;
	l_data=(1<<ENCMP)|(1<<ENCMP_MASK)|(inw(l_reg)&0x00ff0000);
	outw(l_reg,l_data);
}

void DrvCMP_Disable(void)
{
	unsigned int l_reg,l_data;
	l_reg=CMP_CTRL;
	l_data=(1<<ENCMP_MASK)|(inw(l_reg)&0x00ff0000);
	outw(l_reg,l_data);
}

unsigned int DrvCMP_PInput(unsigned int uCPPS)
{
	unsigned int l_reg,l_data,ReturnVal;
	ReturnVal=0;
	l_reg=CMP_INPUT;
	if(uCPPS<(CPPS_MAX+1))
	{
		l_data=(uCPPS<<CPPS)|(CPPS_MAX<<(CPPS+MASK));
		outw(l_reg,l_data);
	}else ReturnVal=E_DRVCMP_ARGUMENT;
	return ReturnVal;
}

unsigned int DrvCMP_NInput(unsigned int uCPNS)
{
	unsigned int l_reg,l_data,ReturnVal;
	ReturnVal=0;
	l_reg=CMP_INPUT;
	if(uCPNS<(CPNS_MAX+1))
	{
	    l_data=(uCPNS<<CPNS)|(CPNS_MAX<<(CPNS+MASK));
		outw(l_reg,l_data);
	}else ReturnVal=E_DRVCMP_ARGUMENT;
	return ReturnVal;
}

unsigned int DrvCMP_InputSwitch (unsigned int uInputSwitch)
{
	// for Bug
	unsigned int l_reg,l_data,ReturnVal;
	ReturnVal=0;
	l_reg=CMP_CTRL;
	if(uInputSwitch<(CPIS_MAX+1))
	{
		l_data=(uInputSwitch<<CPIS)|(CPIS_MAX<<CPIS_MASK)|(inw(l_reg)&0x00ff0000);
		outw(l_reg,l_data);
	}else ReturnVal=E_DRVCMP_ARGUMENT;
	return ReturnVal;

}
/**************************************************************
*name   : DrvCMP_OutputFilter();
*input  : uFilter
*output : 
*version: v1.1
*date   : 2013-11-29
*modify : change the function name
***************************************************************/
unsigned int DrvCMP_OutputFilter(unsigned int uFilter)
{
	unsigned int l_reg,l_data,ReturnVal;
	ReturnVal=0;
	l_reg=CMP_CTRL;
	if(uFilter<(CPDF_MAX+1))
	{
		l_data=(uFilter<<CPDF)|(1<<CPDF_MASK)|(inw(l_reg)&0x00ff0000);
		outw(l_reg,l_data);
	}else ReturnVal=E_DRVCMP_ARGUMENT;
	return ReturnVal;
}

unsigned int DrvCMP_OutputPinEnable(unsigned int uPin)
{
	unsigned int l_reg,l_data;
	if (uPin<CPPTS_MAX+1)
	{
		l_reg=GPIO_CMP_CTRL;
		l_data=(1<<CPPTE)|(1<<CPPTE_MASK)|(uPin<<CPPTS)|(1<<CPPTS_MASK);
		outw(l_reg,l_data);
	}else return E_DRVCMP_ARGUMENT;
	return E_SUCCESS;
}

void DrvCMP_OutputPinDisable(void)
{
	unsigned int l_reg,l_data;
	l_reg=GPIO_CMP_CTRL;
	l_data=(1<<CPPTE_MASK);
	outw(l_reg,l_data);
}

unsigned int DrvCMP_OutputInverse(unsigned int uInv)
{
	unsigned int l_reg,l_data;
	l_reg=CMP_CTRL;
	if(uInv<2)
	{
	    l_data=(uInv<<CPOR)|(1<<CPOR_MASK)|(inw(l_reg)&0x00ff0000);
	    outw(l_reg,l_data);
	}else return E_DRVCMP_ARGUMENT;
	return E_SUCCESS;
}

void DrvCMP_EnableInt(void)
{
	unsigned int l_reg,l_data;
	l_reg=CMP_INTERRUPT_CTRL;
	l_data=(1<<CMPIE)|(1<<CMPIE_MASK);
	outw(l_reg,l_data);
    //l_data=__nds32__mfsr(NDS32_SR_INT_MASK);
    //SETBIT(l_data,3);
    //__nds32__mtsr(l_data, NDS32_SR_INT_MASK);

}

void DrvCMP_DisableInt(void)
{
	unsigned int l_reg,l_data;
	l_reg=CMP_INTERRUPT_CTRL;
	l_data=(1<<CMPIE_MASK);
	outw(l_reg,l_data);
	//l_data=__nds32__mfsr(NDS32_SR_INT_MASK);
	//CLRBIT(l_data,3);
	//__nds32__mtsr(l_data, NDS32_SR_INT_MASK);
}
/**************************************************************
*name   : DrvCMP_ReadIntFlag();
*input  : NO
*output : CMP interrupt flag value
*version: v1.1
*date   : 2013-11-29
*modify : change the operation about get the CMP interrupt flag
***************************************************************/
unsigned int DrvCMP_ReadIntFlag(void)
{
	unsigned int l_reg,ReturnVal;
	ReturnVal=0;
	l_reg=CMP_INTERRUPT_CTRL;
	ReturnVal=(inw(l_reg)>>CMPIF)&0x01;
	return ReturnVal;
}

void DrvCMP_ClearIntFlag(void)
{
	unsigned int l_reg,l_data;
	l_reg=CMP_INTERRUPT_CTRL;
	l_data=(1<<CMPIF_MASK);
	outw(l_reg,l_data);
}

unsigned int DrvCMP_RLO_Ctrl(unsigned int uCPDA ,unsigned int uCPDM)
{
	unsigned int l_reg,l_data,ReturnVal;
	ReturnVal=0;
	l_reg=CMP_CTRL;
	if((uCPDA<(CPDA_MAX+1))&&(uCPDM<(CPDM_MAX+1)))
	{
		l_data=(uCPDA<<CPDA)|(CPDA_MAX<<(CPDA+MASK))|(uCPDM<<CPDM)|(CPDM_MAX<<(CPDM+MASK));
		outw(l_reg,l_data);
	}else ReturnVal=E_DRVCMP_ARGUMENT;
	return ReturnVal;
}
/**************************************************************
*name   : DrvCMP_RLO_refV();
*input  : uCPRH, uCPRLS
*	    uCPRH: 0 OFF
*		     1 CP_I
*		     2 VDD3V
*                3 VDD18
*         uCPRLS: 0 comparator resitor short switch be disable
*                 1 comparator resitor short switch be enable
*output : 
*version: v1.1
*date   : 2013-11-29
*modify : change the operation for setting register cause of the hard ware seting be change
***************************************************************/
unsigned int DrvCMP_RLO_refV(unsigned int uCPRH,unsigned int uCPRLS)
{
	unsigned int l_reg,l_data,ReturnVal;
	ReturnVal=0;
	l_reg=CMP_INPUT;
	if((uCPRH<(CPRH_MAX+1))&&(uCPRLS<(CPRLS_MAX+1)))
	{
		if(uCPRH==0)
			l_data=0|(CPRH_MAX<<+MASK);
		else
			l_data=(CPRH<<(uCPRH-1))|(CPRH_MAX<<MASK);
		l_data=l_data|(uCPRLS<<CPRLS)|(CPRLS_MAX<<(CPRLS+MASK));

		outw(l_reg,l_data);
	}
	else
		ReturnVal=E_DRVCMP_ARGUMENT;
	return ReturnVal;
}

uint32_t DrvCMP_EnableNonOverlap(E_NON_OVERLAP_PIN uInput)
{
	unsigned int l_reg,l_data,ReturnVal;
	ReturnVal=0;
	l_reg=CMP_CTRL;
	if(uInput<(CPCLS_MAX+1))
	{
		l_data=(uInput<<CPCLS)|(CPCLS_MAX<<(CPCLS+MASK))|(1<<ENCLIN)|(ENCLIN_MAX<<(ENCLIN+MASK))|(inw(l_reg)&0x00ff0000);
		outw(l_reg,l_data);
	}else ReturnVal=E_DRVCMP_ARGUMENT;
	return ReturnVal;
}

void DrvCMP_DisableNonOverlap(void)
{
	unsigned int l_reg,l_data;
	l_reg=CMP_CTRL;
	l_data=(ENCLIN_MAX<<(ENCLIN+MASK))|(inw(l_reg)&0x00ff0000);
	outw(l_reg,l_data);
}

unsigned int DrvCMP_ReadData (void)
{
	unsigned int l_reg,ReturnVal;
	l_reg=CMP_INPUT;
	ReturnVal=((inw(l_reg)&(1<<CMPO))>>CMPO);
	return ReturnVal;
}






